﻿using System.Windows;
using System.Windows.Controls;

namespace TestProject
{
    /// <summary>
    /// 메인 윈도우
    /// </summary>
    public partial class MainWindow : Window
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// 체크 메뉴 항목
        /// </summary>
        private MenuItem menuItemChecked;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - MainWindow()

        /// <summary>
        /// 생성자
        /// </summary>
        public MainWindow()
        {
            InitializeComponent();

            AddMenuItem(this.styleMenuItem, "테두리 없음(_N)"       , WindowStyle.None              );
            AddMenuItem(this.styleMenuItem, "단일 테두리 윈도우(_S)", WindowStyle.SingleBorderWindow);
            AddMenuItem(this.styleMenuItem, "3D 테두리 윈도우(_D)"  , WindowStyle.ThreeDBorderWindow);
            AddMenuItem(this.styleMenuItem, "도구 윈도우(_T)"       , WindowStyle.ToolWindow        );
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private
        //////////////////////////////////////////////////////////////////////////////// Event

        #region 메뉴 항목 클릭시 처리하기 - menuItem_Click(sender, e)

        /// <summary>
        /// 메뉴 항목 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void menuItem_Click(object sender, RoutedEventArgs e)
        {
            this.menuItemChecked.IsChecked = false;

            this.menuItemChecked = e.Source as MenuItem;

            this.menuItemChecked.IsChecked = true;

            WindowStyle = (WindowStyle)this.menuItemChecked.Tag;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////// Function

        #region 메뉴 항목 추가하기 - AddMenuItem(parentItem, menuCaption, windowStyle)

        /// <summary>
        /// 메뉴 항목 추가하기
        /// </summary>
        /// <param name="parentItem">부모 항목</param>
        /// <param name="menuCaption">메뉴 제목</param>
        /// <param name="windowStyle">윈도우 스타일</param>
        private void AddMenuItem(MenuItem parentItem, string menuCaption, WindowStyle windowStyle)
        {
            MenuItem menuItem = new MenuItem();

            menuItem.Header    = menuCaption;
            menuItem.Tag       = windowStyle;
            menuItem.IsChecked = (windowStyle == WindowStyle);

            menuItem.Click += menuItem_Click;

            if(menuItem.IsChecked)
            {
                this.menuItemChecked = menuItem;
            }

            parentItem.Items.Add(menuItem);
        }

        #endregion
    }
}